/*
 
  ͻ                   
   OpenSource Library                    
  ͼ                   
   Author : Vitaly Checkryzhev (Virtualik) 
   E-Mail : virty1k@mail.ru                
   WWW    : http://www.str.ru/~virty       
   WWW    : http://virtualsoft.narod.ru    
   WWW    : http://chat.str.ru             
                                           
  VIRtUal Soft         All rights reserved 
 
  
*/

/*
 ࠪ⨪ 襭 #1

  㪫 n-㣮쭨 ( न⠬ ᢮
 設  浪 室).  ࠧ१  㣮쭨 ﬨ,
  祣 室 n-2  (  樥   n).
 ⮨ ࠧ१  㬬   ᯮ짮
 .   ⮨ ࠧ१. ᫮
 ⢨   ࠭祭  童  n.

 㤥 ,  設 ஭㬥஢  1  n  
 ᮢ ५.  k, l -  設, 祬 l>k.
१ A(k,l) 稬 㣮쭨, १  襣
म k--l. ( ठ ࠧ१ 㣮쭨  2,  
 砥 ஭ 1--n; १ A(k,l)  砥 㣮.)
室 㣮쭨 ⢥  A(1,n). 
l=k+1 砥 "㣮쭨"  ᮢ騬 ஭.

१  a(k,l)  稬  ⮨  ࠧ१   㣮쭨
A(k,l) ﬨ  㣮쭨. 襬 ४७ 
  a(k,l).    l=k+1  砥  㣮쭨,   
a(k,l)=0.  l=k+2 砥 㣮쭨,   ⮬ 砥 ⠪-
 a(k,l)=0.  l > k+2. ठ k--l  ஭  -
㣮쭨  A(k,l)  ,  ᫥⥫쭮,  ஭     -
㣮쭨,      ࠧ१. ⨢ 設 i
⮣ 㣮쭨     設 k+1,...,l-1,  -
쭠 ⮨ ࠧ१   ᫥ 

 min {(  k--i)+(  i--l)+a(k,i)+a(i,l)}

 ᥬ i=k+1,..., i=l-1.  ⮬  ,      q=p+1
ठ p--q -  ठ,  ஭,      ࠢ
0 ( ஭ ࠧ१  ஢).

 ⠢ ⠡  a(k,l)     浪 ⠭
᫠ 設 (ࠢ l-k+1),  砥  ணࠬ,  -
  浪 n*n  ६ 浪 n*n*n (⭮
ਬ  ४७⭮    ॡ 롮 㬠  
 祬 n ᥫ). */

#include <stdio.h>
#include <math.h>
#include <alloc.h>

#define debug
#define ptType float

typedef struct { ptType x, y; } TPoint;

// ﭨ  窠  ⮢ ᪮
ptType dist(TPoint p1, TPoint p2)
{
 return sqrt(pow(p2.x - p1.x, 2) + pow(p2.y - p1.y, 2));
}

// ᯥ⪠ ⠡
void printtable(int arrsize, ptType *arr)
{
 for (int i = 0; i < arrsize*arrsize; i++)
 {
  printf("[%.02f] ", arr[i]);
  if ((i+1)%arrsize == 0)
   printf("\n");
 }
}

int main()
{
 // ⨥ 䠩  묨
 FILE *f;
 if ((f = fopen("input.txt", "r")) == NULL)
  {
   printf("Unable to open input data\n");
   return 1;
  }

 // ⥭ - 祪  ।     窠
 int n = 0;
 fscanf(f, "%d\n", &n);
 TPoint *PointList;
 if ((PointList = (TPoint *) malloc(n * sizeof(TPoint))) == NULL)
  {
   printf("Insufficient memory to hold data\n");
   return 2;
  }

 // ।   ᨢ  ﭨﬨ (  ⠬...)
 ptType *a;
 if ((a = (ptType *) malloc(n * n * sizeof(ptType))) == NULL)
  {
   printf("Insufficient memory to hold arr data\n");
   return 3;
  }

 // ⥭  祪
 int i = 0;
 while(!feof(f))
 {
  fscanf(f, "%f %f\n", &PointList[i].x, &PointList[i].y);
  i++;
 }
 fclose(f);

#ifdef debug
 // ᮪ 祪
 printf("Points:\n");
 for (i = 0; i<n; i++)
  printf("\t%d) X: %0.2f, Y: %0.2f\n", i+1, PointList[i].x, PointList[i].y);
#endif

 // --   ७  ⭮,  ய --------
 int l, k;
 float buf, m = 0;
 for (k = 0; k < n; k++)
  for (l = 0; l < n; l++)
  {
   if (l > k + 2)
   {
    m = 0xffff;
    for (int i = k + 1; i < l; i++)
    {
     buf = 0;
     buf += (i - k > 1)?
      dist(PointList[k], PointList[i]) : 0;

     buf += (l - i > 1)?
      dist(PointList[i], PointList[l]) : 0;
     buf += a[i + k*n] + a[l + i*n];

     if (buf < m) m = buf;
    }
    a[l + k*n] = m;
   } else a[l + k*n] = 0;
  }

 printtable(n, a);
 free(PointList);
 return 0;
}
